function [SNR,SNDR,ENOB] = snr_plot(filename,plot_var,plot_flag);
 
%filename = 'test_all.tr0';
x1 = loadsig_cppsim(filename);
%Dout = evalsig(x1,'phase_out');
Dout = evalsig(x1,plot_var);
clear x1;

numpt = length(Dout);
F = ceil(numpt/9000)
fclk = 900e6;
span = 1;

f_dc = [1:span+1];
f_in = [(F*20+1-span):1:(F*20+1+span)];
f_dist2 = [(F*40+1-span):1:(F*40+1+span)];
f_dist3 = [(F*60+1-span):1:(F*60+1+span)];
f_dist4 = [(F*80+1-span):1:(F*80+1+span)];
f_dist5 = [(F*100+1-span):1:(F*100+1+span)];
f_dist6 = [(F*120+1-span):1:(F*120+1+span)];
f_dist7 = [(F*140+1-span):1:(F*140+1+span)];
f_dist8 = [(F*160+1-span):1:(F*160+1+span)];
f_dist9 = [(F*180+1-span):1:(F*180+1+span)];
f_dist10 = [(F*200+1-span):1:(F*200+1+span)];
f_bw = [1:1:(F*200+1+span)];

%Doutw=Dout;
Doutw=Dout'.*hann(numpt);

%Performing the Fast Fourier Transform
Dout_spect=fft(Doutw);
clear Doutw;

%power
S_Dout_spect = Dout_spect.*conj(Dout_spect);

%Recalculate to dB
S_Dout_spect_dB=10*log10(S_Dout_spect);

f = [0:numpt-1].*fclk/numpt;

Ps = sum(S_Dout_spect(f_in));
maxdB = 10*log10(Ps);
Pntot = sum(S_Dout_spect(f_bw));
Pdc = sum(S_Dout_spect(f_dc));
Pdist2 = sum(S_Dout_spect(f_dist2));
Pdist3 = sum(S_Dout_spect(f_dist3));
Pdist4 = sum(S_Dout_spect(f_dist4));
Pdist5 = sum(S_Dout_spect(f_dist5));
Pdist6 = sum(S_Dout_spect(f_dist6));
Pdist7 = sum(S_Dout_spect(f_dist7));
Pdist8 = sum(S_Dout_spect(f_dist8));
Pdist9 = sum(S_Dout_spect(f_dist9));
Pdist10 = sum(S_Dout_spect(f_dist10));
Pdisttot = sum(Pdist2+Pdist3+Pdist4+Pdist5+Pdist6+Pdist7+Pdist8+Pdist9+Pdist10);

SNDR= 10*log10(Ps/(Pntot-Ps-Pdc));
SNR = 10*log10(Ps/(Pntot-Ps-Pdc-Pdisttot));
ENOB=(SNDR-1.763)/6.02;
SFDR = 10*log10(Ps/Pdist2);

if (plot_flag)
   figure 
   semilogx(f(1:numpt/2),S_Dout_spect_dB(1:numpt/2)-maxdB,'r');  
   grid on; 
   title('FFT PLOT'); 
   xlabel('ANALOG INPUT FREQUENCY (MHz)');
   ylabel('AMPLITUDE (dB)'); 
   xlima([1e5 fclk/2])
   ylima([-200 20])
   format;

   text(1e5,-20,strcat('\bf{',filename,'}'))
   text(1e5,-40,strcat('\bf{SNDR = ',num2str(SNDR),'}'))
   text(1e5,-50,strcat('\bf{SNR = ',num2str(SNR),'}'))
   text(1e5,-60,strcat('\bf{ENOB = ',num2str(ENOB),'}'))
end